// Glenn's POV-Ray Generic Include File
// created 12-Feb-97
// last update 12-Jul-98
//
// Copyright 2005 Glenn McCarter (glenn@mccarters.net). Some rights reserved.
// This work is licensed under the Creative Commons Attribution License. 
// To view a copy of this license, visit http://creativecommons.org/licenses/by/2.0/ 

// A single call to this file will include all of Glenn's
// standard include files.
// NOTE: the order these files are specified is important; don't change them!
// NOTE: this file is identical to GInclude.inc,
// except it refers to Glenn's RH coordinate system include files
// (and adds these three comment lines!)

#include "GConstants.inc"
#if ( version < 3.1 ) // load the old versions of these files
	#include "GCamerasRH.inc"
	#include "GTextures.inc"
    #include "GEnvironRH.inc"
    #include "GObjectsRH.inc"
    #include "GShapes.inc"
    #include "GLights.inc"
#else                // load the newest versions
	#include "GCamerasRH31.inc"
	#include "GTextures31.inc"
    #include "GEnvironRH31.inc"
    #include "GObjectsRH31.inc"
    #include "GShapes31.inc"
    #include "GLights31.inc"
#end
#include "GTransforms.inc"


